//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 DarkGray
#property indicator_color2 LimeGreen
#property indicator_color3 Orange
#property indicator_style2 STYLE_DOT
#property indicator_style3 STYLE_DOT

extern int AtrPeriod     = 25;
extern int MaPeriod      = 100;
extern int MaMethod      =  MODE_SMA;
extern int LowsSmaPeriod = 25;
extern int LowsPeriod    = 50;

double atr[];
double ma[];
double malow[];

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,atr);   SetIndexLabel(0,"atr");
   SetIndexBuffer(1,ma);    SetIndexLabel(1,"ma");
   SetIndexBuffer(2,malow); SetIndexLabel(2,"ma of low");
   return(0);
}
int deinit(){return(0);}

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
      int limit = MathMin(Bars-counted_bars,Bars-1);


      for(int i=limit; i>=0; i--) atr[i] = iATR(NULL,0,AtrPeriod,i);
      for(    i=limit; i>=0; i--)
      {
         ma[i]    = iMAOnArray(atr,0,MaPeriod,0,MaMethod,i);
         malow[i] = iSma(atr[ArrayMinimum(atr,LowsPeriod,i)],LowsSmaPeriod,i);
      }         
   return(0); 
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workSma[][2];
double iSma(double price, int period, int r, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= Bars) ArrayResize(workSma,Bars); instanceNo *= 2; r = Bars-r-1;

   //
   //
   //
   //
   //
      
   workSma[r][instanceNo] = price;
   if (r>=period)
          workSma[r][instanceNo+1] = workSma[r-1][instanceNo+1]+(workSma[r][instanceNo]-workSma[r-period][instanceNo])/period;
   else { workSma[r][instanceNo+1] = 0; for(int k=0; k<period && (r-k)>=0; k++) workSma[r][instanceNo+1] += workSma[r-k][instanceNo];  
          workSma[r][instanceNo+1] /= k; }
   return(workSma[r][instanceNo+1]);
}

